 namespace std {
           typedef long unsigned int size_t;
           
         template<class T> struct char_traits;
          }
            
         
      template<class T> class new_allocator;
      template <class CharT          ,class Traits = std::char_traits<CharT>          ,class Allocator = new_allocator<CharT> > class basic_string;
      
      
         namespace move_detail {
      template<int C, typename T1, typename T2> struct if_c {
      typedef T1 type;
   };
      template<typename T1, typename T2> struct if_c<false,T1,T2> {
      typedef T2 type;
   };
      template <bool B, class T = void> struct enable_if_c {
      typedef int type;
   };
      template <class T> struct enable_if_c<false, T> {
  };
      template <class Cond, class T = void> struct enable_if : enable_if_c<Cond::value, int> {
  };
      template <bool B, class T = void> struct disable_if_c    : enable_if_c<!B, int> {
  };
      template <class Cond, class T = void> struct disable_if : enable_if_c<!Cond::value, int> {
  };
      template<class T, T v> struct integral_constant ;
      template<class T, class U> struct is_same {
      static const bool value = false;
   };
      template<class T> struct is_same<T, T> {
      static const bool value = true;
   };
      template< bool C_ > struct bool_ : integral_constant<bool, C_> {
             };
      
      struct no_type ;
      template<class T> struct remove_reference ;
      template<class T> struct add_lvalue_reference {
   typedef char& type;
   };
      template <class T> struct identity {
      typedef T type;
       };
      template<class T> struct addr_impl_ref {
      T & v_;
      inline addr_impl_ref( T & v ): v_( v ) {
  }
      inline operator T& () const {
   return v_;
   }
   };
      template<class T> struct addressof_impl {
      static inline T * f( T & v, long )    {
         return reinterpret_cast<T*>(          &const_cast<char&>(reinterpret_cast<const volatile char &>(v)));
   }
   };
      template<class T> inline T * addressof( T & v ) {
      return ::move_detail::addressof_impl<T>::f       ( ::move_detail::addr_impl_ref<T>( v ), 0 );
   }
      template <class T, class U> class is_convertible {
      
      
      class false_t ;
      static false_t dispatch;
      static int trigger;
      public:    static const bool value = sizeof(0) == sizeof(char);
   };
      template<       bool C     , typename F1     , typename F2     > struct eval_if_c     : if_c<C,move_detail::identity<new_allocator<char> >,int>::type {
  };
      template<class T, class U, class R = void> struct enable_if_convertible    : enable_if< is_convertible<int, int>, int> {
  };
      template<class T, class U, class R = void> struct disable_if_convertible    : disable_if< is_convertible<int, int>, int> {
  };
      template<bool, class B = bool_<false>, class C = bool_<false>, class D = bool_<false>> struct or_impl    : or_impl<B::value, C, D> {
  };
      template<> struct or_impl<false, bool_<false>, bool_<false>, bool_<false>> {
      static const bool value = false;
   };
      template<class B, class C, class D> struct or_impl<true, B, C, D> {
      static const bool value = true;
   };
      template<class A, class B, class C = bool_<false>, class D = bool_<false>> struct or_    : or_impl<A::value, B, C, D> {
  };
      template<class R, class A, class B, class C = bool_<false>, class D = bool_<false>> struct disable_if_or    : disable_if_c< or_<A, B, C, D>::value, R> {
   };
      template <typename T> struct unvoid_ref : add_lvalue_reference<char>{
   };
      template< typename T > struct alignment_of_impl {
   static const std::size_t value = __alignof__(T);
   };
      template< typename T > struct alignment_of    : alignment_of_impl<T> {
  };
      union max_align {
   };
      
      template<std::size_t Len, std::size_t Align> struct aligned_storage_impl;
      template<std::size_t Len>struct  alignas  aligned_storage_impl<Len, 0x8>{
   typedef aligned_storage_impl type;
  };
      template<std::size_t Len, std::size_t Align = alignment_of<int>::value> struct aligned_storage {
      typedef typename aligned_storage_impl<Len ? Len : 1, Align>::type type;
   };
      }
         namespace intrusive {
      
   using move_detail::if_c;
   using move_detail::identity;
   using move_detail::addressof;
   using move_detail::eval_if_c;
   using move_detail::unvoid_ref;
   
      }
         
      namespace container_detail {
   using move_detail::is_convertible;
   using move_detail::disable_if_or;
   template <class Pair> struct select1st ;
   }
      namespace container_detail {
   using ::move_detail::is_same;
   using ::move_detail::alignment_of;
   using ::move_detail::aligned_storage;
   }
      
         namespace intrusive {
      template <typename Ptr> struct pointer_traits ;
      template <typename T> struct pointer_traits<T*> {
      
      typedef T* pointer;
         
      template <class U> struct rebind_pointer    ;
      static pointer pointer_to(typename intrusive::unvoid_ref<T>::type r)    {
   return intrusive::addressof(r);
   }
   };
      }
         
      
   template <typename U, typename Signature> class has_select_on_container_copy_construction ;
   
      namespace container_detail {
   template <typename T, typename DefaultType> struct boost_intrusive_default_type_pointer {
   template <typename X> static char test(int, typename X::pointer*);
   struct DefaultWrap ;
   static const bool value = 1 == sizeof(test<new_allocator<char>>(0, 0));
   typedef typename ::intrusive::if_c <value, new_allocator<char>, int>::type::pointer type;
   };
   template <typename T, typename DefaultType> struct boost_intrusive_eval_default_type_const_pointer {
   template <typename X> static char test(int, typename X::const_pointer*);
   struct DefaultWrap ;
   static const bool value = 1 == sizeof(test<new_allocator<char>>(0, 0));
   typedef typename ::intrusive::eval_if_c < value , int , int >::type::const_pointer type;
   };
   template <typename T, typename DefaultType> struct boost_intrusive_eval_default_type_const_void_pointer ;
   template <typename T, typename DefaultType> struct boost_intrusive_default_type_size_type {
   template <typename X> static char test(int, typename X::size_type*);
   struct DefaultWrap ;
   static const bool value = 1 == sizeof(test<new_allocator<char>>(0, 0));
   typedef typename ::intrusive::if_c <value, new_allocator<char>, int>::type::size_type type;
   };
   template <typename T, typename DefaultType> struct boost_intrusive_default_type_difference_type {
   template <typename X> static int test;
   struct DefaultWrap {
   typedef int difference_type;
   };
   static const bool value = 1 == sizeof(0);
   typedef typename ::intrusive::if_c <value, int, DefaultWrap>::type::difference_type type;
   };
   }
      template <typename Allocator> struct allocator_traits {
      typedef Allocator allocator_type;
      typedef typename allocator_type::value_type value_type;
         typedef typename container_detail:: boost_intrusive_default_type_pointer< Allocator, value_type* >::type             pointer;
         typedef typename container_detail:: boost_intrusive_eval_default_type_const_pointer< Allocator, typename intrusive::pointer_traits<pointer>::template rebind_pointer<const value_type> >::type                const_pointer;
         typedef typename container_detail:: boost_intrusive_default_type_difference_type< Allocator, long >::type             difference_type;
         typedef typename container_detail:: boost_intrusive_default_type_size_type< Allocator, std::size_t >::type             size_type;
      template<class T>    static void destroy( void)                                           noexcept   ;
   };
      
         
            namespace std __attribute__ ((__visibility__ )) {
           struct input_iterator_tag {
      };
           struct forward_iterator_tag : public input_iterator_tag {
      };
           struct bidirectional_iterator_tag : public forward_iterator_tag {
      };
           struct random_access_iterator_tag : public bidirectional_iterator_tag {
      };
         }
            typedef struct 
            __mbstate_t;
            namespace std __attribute__ ((__visibility__ )) {
           template<>     struct char_traits<char>     {
            typedef char char_type;
            static void       assign(char_type& __c1, const char_type& __c2) noexcept       {
   __c1 = __c2;
   }
            static size_t       length(const char_type* __s)       {
   return __builtin_strlen(__s);
   }
            static char_type*       move(char_type* __s1, const char_type* __s2, size_t __n)       {
    return static_cast<char_type*>(__builtin_memmove(__s1, __s2, __n));
         }
            static char_type*       copy(char_type* __s1, const char_type* __s2, size_t __n)       {
    return static_cast<char_type*>(__builtin_memcpy(__s1, __s2, __n));
         }
        };
         }
            extern "C" {
         void  puts (const char *__s);
         }
            
         
      template<class T> class new_allocator {
      public:    typedef char value_type;
      typedef char * pointer;
      typedef const char * const_pointer;
      typedef unsigned long size_type;
   };
      
         namespace intrusive {
      
   template <class T> inline T* to_raw_pointer(T* p) {
   return p;
   }
   
      }
         
      namespace container_detail {
   using ::intrusive::to_raw_pointer;
   }
      
         namespace movelib{
      template<class Iterator> struct iterator_traits {
      typedef typename Iterator::difference_type difference_type;
      typedef typename Iterator::iterator_category iterator_category;
   };
      }
         namespace intrusive {
      using movelib::iterator_traits;
      template<class Category, class T, class Distance, class Pointer = T*, class Reference = T&> struct iterator {
      typedef std::random_access_iterator_tag iterator_category;
      typedef int difference_type;
   };
      template<class I, class Tag, class R = void> struct iterator_enable_if_tag    : ::move_detail::enable_if_c       < ::move_detail::is_same          < typename intrusive::iterator_traits<I>::iterator_category          , Tag          >::value          , int> {
  };
      template<class I, class Tag> struct iterator_enable_if_tag_difference_type    : iterator_enable_if_tag<I, Tag, typename intrusive::iterator_traits<I>::difference_type> {
  };
      template<class InputIt> inline typename iterator_enable_if_tag_difference_type    <InputIt, std::random_access_iterator_tag>::type       iterator_distance( InputIt last) {
    
   }
      }
         
      using ::intrusive::iterator_distance;
      using ::intrusive::iterator;
      
         
      template <class T, class Difference = long> class constant_iterator   : public ::iterator       <int, char, int, const char*, const char &> {
      
      public:    explicit constant_iterator(const char &ref, int range_size)       : m_ptr(&ref), m_num(range_size){
  }
      constant_iterator()       : m_ptr(0), m_num(0){
  }
      void  operator++()    {
   {
      --m_num;
      }
   
   ;
   }
      friend bool operator== (const constant_iterator& i, const constant_iterator& i2)    {
   return i.equal(i2);
   }
      friend bool operator!= (const constant_iterator& i, const constant_iterator& i2)    {
   return !(i == i2);
   }
      const char& operator*() const    {
   }
      private:    const char * m_ptr;
      int m_num;
      
      bool equal(const constant_iterator<char, int> &other) const    {
   return m_num == other.m_num;
   }
   };
      namespace container_detail {
   template<class T> struct has_iterator_category {
      struct two ;
      template <typename X>    static char test;
      static const bool value = 1 == sizeof(0);
   };
   template<class T, bool = has_iterator_category<T>::value > struct is_input_iterator {
      static const bool value = is_same<typename T::iterator_category, int>::value;
   };
   template<class T> struct is_not_input_iterator {
      static const bool value = !is_input_iterator<T>::value;
   };
   template<class IIterator, bool IsConst> class iterator_from_iiterator ;
   template <class Allocator> class basic_string_base {
      typedef new_allocator<char>  allocator_traits_type;
    public:    typedef new_allocator<char> allocator_type;
      typedef typename allocator_traits_type::pointer pointer;
      typedef typename allocator_traits_type::value_type value_type;
      typedef typename allocator_traits_type::size_type size_type;
      
      
      private:    struct long_t    {
         
         size_type storage;
         pointer start;
      };
      struct short_header    {
         unsigned char is_short : 1;
         unsigned char length : 8 - 1;
      };
      
      protected:    static const size_type MinInternalBufferChars = 8;
      static const size_type AlignmentOfValueType =       alignment_of<value_type>::value;
      static const size_type ShortDataOffset = sizeof-1/AlignmentOfValueType+1*AlignmentOfValueType;
      static const size_type ZeroCostInternalBufferChars =       sizeof(long_t) - ShortDataOffset/sizeof(value_type);
      static const size_type UnalignedFinalInternalBufferChars =       ZeroCostInternalBufferChars;
      struct short_t    {
         short_header h;
         value_type data[ZeroCostInternalBufferChars];
      };
      union repr_t    {
         typename container_detail::aligned_storage<sizeof(long_t), container_detail::alignment_of<long_t>::value>::type r;
         short_t s;
         const short_t &short_repr() const       {
   return s;
   }
         
      };
      struct members_holder       : public new_allocator<char>    {
         members_holder()          : new_allocator<char>()       {
  }
         repr_t m_repr;
      }
   members_;
      protected:    bool is_short() const    {
         short_header hdr;
         *(unsigned char*)&hdr = *(unsigned char*)&this->members_.m_repr;
         return hdr.is_short != 0;
      }
      
      pointer priv_short_addr() const    {
   return ::intrusive::pointer_traits<pointer>::pointer_to(const_cast<value_type&>(this->members_.m_repr.short_repr().data[0]));
   }
      pointer priv_long_addr() const    {
   }
      pointer priv_addr() const    {
         return this->is_short()          ? priv_short_addr()          : 0          ;
      }
      pointer priv_end_addr() const    {
         return this->is_short()          ? this->priv_short_addr() + this->priv_short_size()          : this->priv_long_addr() + 0          ;
      }
      size_type priv_size() const    {
   return this->is_short() ? this->priv_short_size() : 0;
   }
      size_type priv_short_size() const    {
   return this->members_.m_repr.short_repr().h.length;
   }
      
      void priv_size(size_type sz)    {
         this->is_short();
         
          this->priv_short_size(sz);
      }
      void priv_short_size(size_type sz)    {
         this->members_.m_repr.s.h.length = sz;
      }
      
   };
   }
      template <class CharT, class Traits, class Allocator> class basic_string    : private container_detail::basic_string_base<Allocator> {
      typedef container_detail::basic_string_base<Allocator> base_t;
      static const typename base_t::size_type InternalBufferChars = base_t::InternalBufferChars;
      protected:    template <class Tr>    struct Eq_traits    ;
      typedef typename ::allocator_traits<Allocator>::pointer pointer;
      
      typedef char  size_type;
      
      typedef Allocator allocator_type;
      typedef pointer iterator;
      typedef typename ::allocator_traits<Allocator>::const_pointer const_iterator;
      private:    typedef constant_iterator<char, typename ::allocator_traits<Allocator>::difference_type> cvalue_iterator;
      public:    struct reserve_t ;
      explicit basic_string(const allocator_type& a)                                                   noexcept      : base_t(a)    {
      }
      basic_string(const CharT* s)       : base_t()    {
         this->assign(s, s + Traits::length(s));
      }
      basic_string& operator=(const basic_string & x)    ;
      iterator begin()                     noexcept   {
   return this->priv_addr();
   }
      iterator end()                   noexcept   {
   return this->priv_end_addr();
   }
      size_type size() const                              noexcept   {
   return this->priv_size();
   }
      size_type length() const                             noexcept   {
   return this->size();
   }
      void resize(size_type n, CharT c)    {
         if (n <= this->size())          this->erase(this->begin() + n, this->end());
         else          this->append(n - this->size(), c);
      }
      void resize(size_type n)    {
   resize(n, CharT());
         if (n <= this->size())          this->erase(this->begin() + n, this->end());
         else;
      }
      size_type capacity() const                               noexcept   ;
      
      void  append(size_type n, char c)    {
    this->append(cvalue_iterator(c, n), cvalue_iterator());
   }
      template <class InputIter>    void  append(InputIter first, InputIter last)    {
   this->insert(0, first, last);
      }
       char *assign_ptr = container_detail::to_raw_pointer(this->priv_addr());
void  assign(const char* first, const char* last)     {
          size_type n = static_cast<size_type>(last - first);
          
          std::char_traits<char>::copy(assign_ptr, first, n);
          this->priv_size(n);
       }
      template <class InputIter>    void  insert(   typename container_detail::disable_if_or          < void          , container_detail::is_convertible<InputIter, size_type>          , container_detail::is_not_input_iterator<InputIter>          >::type * = 0       )    ;
      template <class ForwardIter>    void  insert(const_iterator p, ForwardIter first, ForwardIter last              )    {
         if (first != last) {
            const size_type n = iterator_distance( last);
            const size_type old_size = this->priv_size();
            const size_type remaining = 0 - old_size;
            const pointer old_start = this->priv_addr();
            if (remaining >= n){
               const size_type elems_after = old_size - (p - old_start);
               if (elems_after >= n) 
                  this->priv_copy(first, last, const_cast<char*>(container_detail::to_raw_pointer(p)));
               
            }
         }
      }
      void  erase(const_iterator first, const_iterator last)                                                              noexcept   {
         CharT * f = const_cast<CharT*>(container_detail::to_raw_pointer(first));
         if (first != last) {
            const size_type old_size = this->priv_size();
            Traits::move(f,                       container_detail::to_raw_pointer(last),                       old_size + 1-(last - this->priv_addr()));
         }
      }
      template <class ForwardIter>    basic_string& replace(const_iterator i1, const_iterator i2, ForwardIter j1, ForwardIter j2       , typename container_detail::disable_if_or          < void          , container_detail::is_convertible<ForwardIter, size_type>          , container_detail::is_not_input_iterator<ForwardIter>          >::type * = 0       )    ;
      const char* c_str() const                               noexcept   {
   return container_detail::to_raw_pointer(this->priv_addr());
   }
      template<class FwdIt, class Count> inline    void priv_uninitialized_fill_n(FwdIt first, Count count, const CharT val)    ;
          ;
      template <class InputIterator, class OutIterator>    void priv_copy(InputIterator first, InputIterator last, OutIterator result)    {
         for ( ;
   first != last;
   ++first, ++result)          std::char_traits<char>::assign(*result, *first);
      }
   };
       
        
            
            basic_string<char, std::char_traits<char>, new_allocator<char> > normalize(basic_string<char, std::char_traits<char>, new_allocator<char> > token) {
           if (token.length() >= 2) 
          token.resize(token.length() - 2);
        
           return token;
         }
            int main() {
           puts(normalize("string").c_str());
         }
 